//+------------------------------------------------------------------+
//|                                               cheduecoglioni.mq5 |
//|                                                   Gianni Esperti |
//|                                  https://www.gianniesperti.come? |
//+------------------------------------------------------------------+
#property copyright "Gianni Esperti"
#property link      "https://www.gianniesperti.come?"
#property version   "1.000"
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
#include <Trade\PositionInfo.mqh>
#include <Trade\Trade.mqh>
CPositionInfo  m_position;                   // trade position object
CTrade         m_trade;                      // trading object
//---
ulong                m_magic=15489;                // magic number
ENUM_POSITION_TYPE   m_close_pos_type=POSITION_TYPE_BUY;
datetime             m_time_last_trade=0;
bool                 m_is_trade=true;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   m_trade.SetExpertMagicNumber(m_magic);
   m_close_pos_type=POSITION_TYPE_BUY;
   m_time_last_trade=0;
   m_is_trade=true;
//---
   return (INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(TimeCurrent()-m_time_last_trade>60 && m_is_trade)
     {
      MqlTick last_tick;
      if(!SymbolInfoTick(Symbol(),last_tick))
         return;
      if(last_tick.ask==0.0 || last_tick.bid==0.0)
         return;
      Print(__FUNCTION__", TimeCurrent()-m_time_last_trade=",(long)(TimeCurrent()-m_time_last_trade));

      if(m_close_pos_type==POSITION_TYPE_SELL)
        {
         Print("Open Buy");
         m_trade.Buy(0.01,NULL,last_tick.ask,
                     last_tick.bid-100*Point(),
                     last_tick.bid+100*Point());
        }
      else if(m_close_pos_type==POSITION_TYPE_BUY)
        {
         Print("Open Sell");
         m_trade.Sell(0.01,NULL,last_tick.bid,
                      last_tick.ask+100*Point(),
                      last_tick.ask-100*Point());
        }

     }
  }
//+------------------------------------------------------------------+
//| TradeTransaction function                                        |
//+------------------------------------------------------------------+
void OnTradeTransaction(const MqlTradeTransaction &trans,
                        const MqlTradeRequest &request,
                        const MqlTradeResult &result)
  {
//--- get transaction type as enumeration value 
   ENUM_TRADE_TRANSACTION_TYPE type=trans.type;
//--- if transaction is result of addition of the transaction in history
   if(type==TRADE_TRANSACTION_DEAL_ADD)
     {
      long     deal_entry        =0;
      long     deal_type         =0;
      string   deal_symbol       ="";
      long     deal_magic        =0;
      long     deal_time         =0;
      if(HistoryDealSelect(trans.deal))
        {
         deal_entry=HistoryDealGetInteger(trans.deal,DEAL_ENTRY);
         deal_type=HistoryDealGetInteger(trans.deal,DEAL_TYPE);
         deal_symbol=HistoryDealGetString(trans.deal,DEAL_SYMBOL);
         deal_magic=HistoryDealGetInteger(trans.deal,DEAL_MAGIC);
         deal_time=HistoryDealGetInteger(trans.deal,DEAL_TIME);
        }
      else
         return;
      if(deal_symbol==Symbol() && deal_magic==m_magic)
        {
         if(deal_entry==DEAL_ENTRY_OUT)
           {
            if(deal_type==DEAL_TYPE_BUY || deal_type==DEAL_TYPE_SELL)
              {
               m_close_pos_type=(deal_type==DEAL_TYPE_BUY)?POSITION_TYPE_SELL:POSITION_TYPE_BUY;
               m_time_last_trade=(datetime)deal_time;
               m_is_trade=true;
               Print(__FUNCTION__", DEAL_ENTRY_OUT, m_time_last_trade=",TimeToString(m_time_last_trade));
              }
           }
         else if(deal_entry==DEAL_ENTRY_IN)
           {
            m_time_last_trade=(datetime)deal_time/*TimeCurrent()*/;
            m_is_trade=false;
           }
        }
     }
  }
//+------------------------------------------------------------------+
